FUNCTION cylinder::Init, radius=radius, height=height, DENSITY=density, $
                     _EXTRA=e
    IF (self->IDLgrModel::Init(_EXTRA=e) NE 1) THEN RETURN, 0
    self.radius=0.7
    self.height=0.7
    self.density = 10
    IF (N_ELEMENTS(radius) EQ 1) THEN self.radius = radius
    IF (N_ELEMENTS(height) EQ 1) THEN self.height = height
    IF (N_ELEMENTS(density) EQ 1) THEN self.density = density
    self.oPoly = OBJ_NEW('IDLgrPolygon', SHADING=1, _EXTRA=e)
    self->Add,self.oPoly
    self->BuildPoly
    RETURN, 1
END

;----------------------------------------------------------------------------
PRO cylinder::Cleanup
    OBJ_DESTROY, self.oPoly
    self->IDLgrModel::Cleanup
END

;----------------------------------------------------------------------------
PRO cylinder::SetProperty, radius=radius, height=height, DENSITY=density, _EXTRA=e
    self->IDLgrModel::SetProperty, _EXTRA=e
    self.oPoly->SetProperty, _EXTRA=e
    IF (N_ELEMENTS(radius) EQ 1) THEN self.radius = radius
    IF (N_ELEMENTS(height) EQ 1) THEN self.height = height
    IF (N_ELEMENTS(density) EQ 1) THEN self.density = density
    self->BuildPoly
END

;----------------------------------------------------------------------------
PRO cylinder::GetProperty, radius=radius, height=height, DENSITY=density,$
                         POBJ=pobj, _EXTRA=e
    self->IDLgrModel::GetProperty, _EXTRA=e
    self.oPoly->GetProperty, _EXTRA=e
    radius = self.radius
    height=self.height
    density = self.density
    pobj = self.oPoly
END

;----------------------------------------------------------------------------
PRO cylinder::BuildPoly

    ;---------------data-----------------
    distance=self.height*findgen(self.density)/(self.density-1)
    fi=2*!pi*findgen(4*(self.density-1))/(4*(self.density-1))
    nfi=n_elements(fi)
    ndistance=n_elements(distance)
    n=ndistance*nfi

    x=findgen(n)
    y=findgen(n)
    z=findgen(n)

    for i=0,ndistance-1 do begin
        i2=ndistance-1-i
        for j=0,nfi-1 do begin
            x(j+i*nfi)=self.radius*cos(fi(j))
            y(j+i*nfi)=self.radius*sin(fi(j))
            z(j+i*nfi)=distance(i2)
        endfor
    endfor

    data=transpose([[x],[y],[z]])

    ;--------------polygons----------------------------

    dim=nfi*(ndistance-1)
    polygon1=intarr(5,dim)
    polygon1(0,*)=4
    polygon1(1,*)=indgen(dim)
    polygon1(2,*)=indgen(dim)+1
    polygon1(3,*)=indgen(dim)+nfi+1
    polygon1(4,*)=indgen(dim)+nfi
    for i=0,ndistance-2 do begin
        polygon1(2,(i+1)*nfi-1)=polygon1(1,i*nfi)
        polygon1(3,(i+1)*nfi-1)=polygon1(4,i*nfi)
    endfor
    polygon1=reform(polygon1,5*dim)

    self.oPoly->SetProperty, DATA=data , POLYGONS=polygon1

END

;-----------------------------------------------------------
PRO cylinder_define
    struct = { cylinder, $
               INHERITS IDLgrModel, $
               radius:0.7,$
               height: 0.7,$
               density: 10, $
               oPoly: OBJ_NEW() $
             }
END







