FUNCTION spiral_bottom::Init, POS=pos, r=r, dist=dist, height=height, width=width, DENSITY=density, $
                     _EXTRA=e
    IF (self->IDLgrModel::Init(_EXTRA=e) NE 1) THEN RETURN, 0
    self.r=0.2
    self.dist=0.2
    self.height=1.0
    self.width=0.0
    self.density = 10
    self.pos = [0.0,0.0,0.0]
    IF (N_ELEMENTS(r) EQ 1) THEN self.r = r
    IF (N_ELEMENTS(dist) EQ 1) THEN self.dist = dist
    IF (N_ELEMENTS(height) EQ 1) THEN self.height = height
    IF (N_ELEMENTS(width) EQ 1) THEN self.width = width
    IF (N_ELEMENTS(density) EQ 1) THEN self.density = density
    IF (N_ELEMENTS(pos) EQ 3) THEN self.pos = pos
    self.oPoly = OBJ_NEW('IDLgrPolygon', SHADING=1, _EXTRA=e)
    self->Add,self.oPoly
    self->BuildPoly
    RETURN, 1
END

;----------------------------------------------------------------------------
PRO spiral_bottom::Cleanup
    OBJ_DESTROY, self.oPoly
    self->IDLgrModel::Cleanup
END

;----------------------------------------------------------------------------
PRO spiral_bottom::SetProperty, POS=pos, r=r, dist=dist, height=height, width=width, DENSITY=density, _EXTRA=e
    self->IDLgrModel::SetProperty, _EXTRA=e
    self.oPoly->SetProperty, _EXTRA=e
    IF (N_ELEMENTS(r) EQ 1) THEN self.r = r
    IF (N_ELEMENTS(dist) EQ 1) THEN self.dist = dist
    IF (N_ELEMENTS(height) EQ 1) THEN self.height = height
    IF (N_ELEMENTS(width) EQ 1) THEN self.width = width
    IF (N_ELEMENTS(density) EQ 1) THEN self.density = density
    IF (N_ELEMENTS(pos) EQ 3) THEN self.pos = pos
    self->BuildPoly
END

;----------------------------------------------------------------------------
PRO spiral_bottom::GetProperty, POS=pos, r=r, dist=dist, height=height, width=width, DENSITY=density,$
                         POBJ=pobj, _EXTRA=e
    self->IDLgrModel::GetProperty, _EXTRA=e
    self.oPoly->GetProperty, _EXTRA=e
    r = self.r
    dist = self.dist
    height=self.height
    width=self.width
    density = self.density
    pobj = self.oPoly
    pos = self.pos
END

;----------------------------------------------------------------------------
PRO spiral_bottom::BuildPoly

    ;---------------data-----------------
    t=2*!pi*self.pos(2)/self.dist ;pro pos(2)=0 t=0 a pro pos(2)=h t=konst
    nrad=3
    rad=self.width*findgen(nrad)/(nrad-1)
    nfi=self.density
    fi=2*!pi*findgen(nfi)/nfi
    n=(nrad-1)*nfi+1
    x=findgen(n)
    y=findgen(n)
    z=findgen(n)

    ;B=[self.r*cos(omega*t),self.r*sin(omega*t),vz*t]
    ;vx=-omega*B(1) ;ziskame jako derivaci x, y a z
    ;vy=omega*B(0)
    ;vz=vz
    ;v=sqrt(vx^2+vy^2+vz^2)
    ;costheta=vz/v
    ;sintheta=sqrt((vx^2+vy^2)/(v^2))
    ;cosksi=vy/(v*sintheta)
    ;sinksi=vx/(v*sintheta)
    ;M=[[cosksi,sinksi*costheta,sinksi*sintheta],[-sinksi,cosksi*costheta,cosksi*sintheta],[0.0,-sintheta,costheta]]

    for i=0,nrad-2 do begin
        i2=nrad-1-i
        for j=0,nfi-1 do begin
            ;point=[rad(i2)*cos(fi(j)),rad(i2)*sin(fi(j)),0.0]
            ;point=(M##point)+B
            ;x(j+i*nfi)=point(0)
            ;y(j+i*nfi)=point(1)
            ;z(j+i*nfi)=point(2)
            x(j+i*nfi)=rad(i2)*cos(fi(j))*cos(t)-rad(i2)*sin(fi(j))*sin(t)*self.dist/(2*!pi*sqrt((self.r)^2+(self.dist/(2*!pi))^2))+self.r*cos(t)
            y(j+i*nfi)=rad(i2)*cos(fi(j))*sin(t)+rad(i2)*sin(fi(j))*cos(t)*self.dist/(2*!pi*sqrt((self.r)^2+(self.dist/(2*!pi))^2))+self.r*sin(t)
            z(j+i*nfi)=-rad(i2)*sin(fi(j))*self.r/sqrt(((self.r)^2+(self.dist/(2*!pi))^2))+t*self.dist/(2*!pi)
        endfor
    endfor
    ;x(n-1)=B(0)
    ;y(n-1)=B(1)
    ;z(n-1)=B(2)
    x(n-1)=self.r*cos(t)
    y(n-1)=self.r*sin(t)
    z(n-1)=t*self.dist/(2*!pi)


    data=transpose([[x],[y],[z]])


    ;--------------polygons----------------------------
    dim=nfi*(nrad-2)
    polygon1=intarr(5,dim)
    polygon1(0,*)=4
    polygon1(1,*)=indgen(dim)
    polygon1(2,*)=indgen(dim)+1
    polygon1(3,*)=indgen(dim)+nfi+1
    polygon1(4,*)=indgen(dim)+nfi
    for i=0,nrad-3 do begin
        polygon1(2,(i+1)*nfi-1)=polygon1(1,i*nfi)
        polygon1(3,(i+1)*nfi-1)=polygon1(4,i*nfi)
    endfor
    polygon1=reform(polygon1,5*dim)

    polygon2=intarr(4,nfi)
    polygon2(0,*)=3
    polygon2(1,*)=indgen(nfi)+dim
    polygon2(2,*)=indgen(nfi)+dim+1
    polygon2(3,*)=n-1
    polygon2(2,nfi-1)=polygon2(1,0)
    polygon2=reform(polygon2,4*nfi)

    polygons=[polygon1,polygon2]

    self.oPoly->SetProperty, DATA=data , POLYGONS=polygons

END

;-----------------------------------------------------------
PRO spiral_bottom_define
    struct = { spiral_bottom, $
               INHERITS IDLgrModel, $
               pos:[0.0,0.0,0.0],$
               r:0.2,$
               dist:0.2,$
               height: 1.0,$
               width:0.0,$
               density: 10, $
               oPoly: OBJ_NEW() $
             }
END







